﻿print '-------------------- Pre-deploy --------------------------'

----tato podminka ma zabranit deploy samotneho DACPAC. Pokud se provede deploy bez bootstrapperu, tak se odstrani vlastni sloupce!
--if( $(DbSecret)!='A063CCD5-2E5E-4EBD-9001-0A30483048B6' )
--begin
--	print 'Error: DACPAC cannot be deployed alone! Use AlvaoDeploy.exe project!'
--	raiserror(N'DACPAC cannot be deployed alone! Use AlvaoDeploy.exe project! ',16,1)
--	return
--end

GO

if exists(select 1 from sys.tables where name='tDb')
begin
	if (select count(1) from tDb)=1
	begin
		--kontrola jazyka
		if not exists(select 1 from tDb where iDbLocaleId=$(LangId))
		begin
			print 'Cannot upgrade database - database is in different language.'
			raiserror(N'Cannot upgrade database - database is in different language.',16,1)
			return
		end

		----podporovane verze DB
		--if not exists(select 1 from tDb where Version in ('103e','103f','104a') or Version is null or Version='0')
		--begin
		--	print 'Unsupported database version'
		--	raiserror(N'Unsupported database version',16,1)
		--	return
		--end
	end
end

GO

begin tran

GO
--pomocna temp tabulka pro ukladani ruznych dat pro PostDeployment skript
create table #properties (Property nvarchar(255), BitValue bit null)
insert into #properties (Property, BitValue) values
('tblWbemObject.NumberOfCoresExists', (SELECT CASE WHEN EXISTS(SELECT 1 FROM sys.columns WHERE Name = N'NumberOfCores' AND Object_ID = Object_ID(N'dbo.tblWbemObject')) THEN 1 ELSE 0 END)),
('tblLicHistItem.LicensesCountExists', (SELECT CASE WHEN EXISTS(SELECT 1 FROM sys.columns WHERE Name = N'LicensesCount' AND Object_ID = Object_ID(N'dbo.tblLicHistItem')) THEN 1 ELSE 0 END))

GO
--transformace sHdTicketStateNotice
if exists(select 1 from sys.tables st join sys.columns sc on sc.object_id=st.object_id where st.name='tHdTicket' and sc.name='sHdTicketStateNotice')
begin
	exec ('insert into TicketState (TicketTypeId, TicketState,  [Order], TicketStateBehaviorId, Removed)
	select TicketTypeId, 
		sHdTicketStateNotice, 
		isnull(MaxOrder, 3999) + ROW_NUMBER() OVER(PARTITION BY TicketTypeId ORDER BY sHdTicketStateNotice) as NewOrder,
		10 as TicketStateBehaviorId,
		GETUTCDATE() as Removed
	from (
		select S.TicketTypeId, T.sHdTicketStateNotice, MAX(TS.[Order]) as MaxOrder
		from tHdTicket T
			join tHdSection S on S.iHdSectionId = T.liHdTicketHdSectionId
			left join TicketState TS on TS.TicketTypeId = S.TicketTypeId and TS.[Order] between 4000 and 4999
		where T.sHdTicketStateNotice not in (select TS2.TicketState from TicketState TS2 where TS2.TicketTypeId = S.TicketTypeId or TS2.TicketStateBehaviorId in (4,6,7,9))
			and isnull(T.TicketStateId,0) not in (select TS2.id from TicketState TS2 where TS2.TicketStateBehaviorId in (4,6,7,9))
		group by S.TicketTypeId, T.sHdTicketStateNotice
	) sub

	update T set TicketStateId = TS.id
	from tHdTicket T
		join tHdSection S on S.iHdSectionId = T.liHdTicketHdSectionId
		join TicketState TS on TS.TicketTypeId = S.TicketTypeId and TS.TicketState = T.sHdTicketStateNotice and TS.Removed is null
	where T.TicketStateId is null or T.TicketStateId not in (select TS2.id from TicketState TS2 where TS2.TicketTypeId = S.TicketTypeId or TS2.TicketStateBehaviorId in (4,6,7,9))

	update T set TicketStateId = TS.id
	from tHdTicket T
		join tHdSection S on S.iHdSectionId = T.liHdTicketHdSectionId
		join TicketState TS on TS.TicketTypeId = S.TicketTypeId and TS.TicketState = T.sHdTicketStateNotice and TS.Removed is not null
	where T.TicketStateId is null or T.TicketStateId not in (select TS2.id from TicketState TS2 where TS2.TicketTypeId = S.TicketTypeId or TS2.TicketStateBehaviorId in (4,6,7,9))')
end

GO

--jinak nejde alter column na not null
if exists(select 1 from sys.columns where name='txtName' and object_id=object_id('tblProduct') and is_nullable=1)
	alter table tblProduct drop column FullName

GO

if exists(select 1 from sys.tables where name='tComputer')
	update tRole set sDesc = null, RoleBehaviorId = 1 where RoleBehaviorId = 4

GO

print '-------------------- Changing schema ---------------------'
GO
